function [C1,C2,Na,K1,K2] = contRepWithClMeans(Nv1,Nv2,time1,time2,grid,classes);
% [C1,C2,K1,K2,Na] = contRepWithClMeans(Nv1,Nv2,time1,time2,grid,classes);
%
% Nv1,Nv2 - the two expression data sets
% time1,time2 - times for the two datasets. times1 is used to do
% interpolation. the estimated splines are evaluated at time2 to give C2
% grid - njumber of spline curves (= # ctrl points -2) (min:2 max: n+1)
% classes - number of classes to use (typically 3)
%
% output:
% C1: estimated function values at times1
% C2: estimated function values at times2
% Na: clustering information. typically 3 clusters so that max(Na)=3, min(Na)=1
% K1: cluster means of estimated function values, at times1
% K2: cluster means of estimated function values, at times2

[C1,C2,Na] = contRep(Nv1,Nv2,time1,time2,grid,classes);

for i=1:classes
  K1(i,:) = sum( C1(find(Na==i),:), 1) / max(size(find(Na==i)));
  K2(i,:) = sum( C2(find(Na==i),:), 1) / max(size(find(Na==i)));
end
