load SimData;
%D = dataA;
%D = dataB;
%D = dataC;
D = dataD;
T = [1 2 3 8 16 22 23 24];
maxT = T(end);

gcvCntrlPts = 4;
x = getS(T,gcvCntrlPts); 
Agcv = x * pinv(x);


classes = 3;
[lcv_BestCntrlPts, lcv_Scores, lcv_Asmall, lcv_Alarge, lcv_estVal, ...
 lcv_estClstrMeans, lcv_class] = lcv(D, T, Agcv, classes);

sigma = 0.2;
z_alpha2= 1; %for now...this constant doesn't matter


%first strategy for calculating CIs (confidence intervals):
%  CI at a sampled point is given by CI(i) Z(alpha/2)* sqrt( lcv_Asmall(i,i,i) * sigma)
%  at an unsampled point: find neigbouring sampled pts on either side,
%  get CI as weighted sum of CI(left) and CI(right)

% assumes T is sorted from 1 to Max

CIa = zeros(1,maxT);
n = max(size(T));
for i=1:n
  CIa(T(i)) = z_alpha2 * sqrt( lcv_Asmall(i,i,i) * sigma);
end
CIa1 = CIa;

for i=1:n-1
  distance = T(i+1) - T(i); % distance to next sampled point
  for k=T(i)+1:T(i+1)-1
    left = CIa(T(i));
    right = CIa(T(i+1));
    
    rightDist = T(i+1)-k;
    leftDist = k-T(i);
    CIa(k) = ( rightDist*left + leftDist*right ) / distance;
  end
end


%second strategy for calculating CIs (confidence intervals):
%  CI at a sampled point is given by CI(i) Z(alpha/2)* sqrt( lcv_Alarge(i,i,i) * sigma)
%  at an unsampled point: find CI using lcv_Alarge of left sampled
%  neighbour and CI using lcv_Alarge of right sampled neighbour and
%  take a weighted sum

% assumes T is sorted from 1 to Max

CIb = zeros(1,maxT);
n = max(size(T));
for i=1:n
  CIb(T(i)) = z_alpha2 * sqrt( lcv_Alarge(i,T(i),T(i)) * sigma);
end
CIb1 = CIb;

CIb_left  = CIb;
CIb_right = CIb;

for i=1:n-1
  distance = T(i+1) - T(i); % distance to next sampled point
  for k=T(i)+1:T(i+1)-1
    CIb_left(k) = z_alpha2 * sqrt( lcv_Alarge(i,k,k) * sigma);
    CIb_right(k) = z_alpha2 * sqrt( lcv_Alarge(i+1,k,k) * sigma);
    rightDist = T(i+1)-k;
    leftDist = k-T(i);
    CIb(k) = ( rightDist*CIb_left(k) + leftDist*CIb_right(k) ) / distance;
  end
end
