% for the paper. for sim data (for ErrThreshold vs. # timepoints) only use dataA, dataE, dataI
load SimData;

dSets = {dataA, dataB, dataD, dataE, dataG, dataH, dataI};
dSetNames = {'dataA', 'dataB', 'dataD', 'dataE', 'dataG', 'dataH', 'dataI'};
dQual     = {'Easy','Hard','Easy','Moderate','Moderate','Moderate','Hard'};
trueErrThreshold = 0.15;

figure;

doGcvErrorVsTimePoints=1;
i=1;
for j=[1 4 2]%length(dSets)

  [dPlotMat, rPlotMat, dStopAt, rStopAt] = ...
      test4_anlyz_trueErrvsTimePts(j,trueErrThreshold);

  if (doGcvErrorVsTimePoints)
    subplot(1,3,i);
    %BEGIN true error vs timepoints
    err_desc='GCV-error';

    [dIdx,dTrueErr,dErrMetric,rIdx,rTrueErr,rErrMetric] = ...
	test4_anlyz_trueErrvsErrMetric(j, trueErrThreshold, dPlotMat, rPlotMat, dStopAt, rStopAt, err_desc);
    
    err_min =min([dErrMetric rErrMetric])-0.3;
    err_max =err_min+3;

    [a, sortR] = sort(rTrueErr);
    [b, sortD] = sort(dTrueErr);
     plot(dIdx, dErrMetric, 'ko-', rIdx, rErrMetric,'r*-',dIdx, ...
	  dErrMetric,'ko',rIdx,rErrMetric,'r*');
     % ,[4 22], [trueErrThreshold trueErrThreshold], 'g--',[dStopAt dStopAt],[0 dPlotMat(dStopAt-4,2)],'k-.',[rStopAt  rStopAt],[0 rPlotMat(rStopAt-4,2)],'r-.');
    v = axis;
    axis([v(1) v(2) 2 6.5]);
    [LEGH,OBJH,OUTH,OUTM] = legend('ActiveLearn','Random');
    set(LEGH,'FontSize', 10);
    
    s=sprintf('%s',dQual{j});
    title(s,'FontSize', 11,'FontWeight','bold');  
    if (j==1) 
      ylabel('GCV-error','FontSize', 11,'FontWeight','bold');
    end
    if (j==4)
      xlabel('Number of Time-points','FontSize', 11,'FontWeight','bold');
    end
  end
  
  
  %figname = sprintf('test4_2in1_gcverror_%s.tiff',dSetNames{j});
  %print(gcf, '-dtiff',figname);
  %figure;
i = i+1;
end
exportfig(gcf,'sim_et_figs3.eps','width',4.5,'height',3,'Color','cmyk')
%close;


