%../evaluation/simulation/eyeball/README
%
%test1: for datasets={dataA, dataB, dataD, dataE} and with cost={0.8,
%0.9, 1.0} and with strategies {gcv, lcv-smart, gcv-activelearning,
%lcv-activelearning}:
%
%  test1a: make a plot of the 4 strats against each other for each cost function (4 x 3 plots)



% test1a_run.m;



load SimData;

dSets = {dataA, dataB, dataD, dataE};
dSetNames = {'dataA', 'dataB', 'dataD', 'dataE'};

costs = [0.8, 0.9, 1.0];
costNames = {'0_8', '0_9', '1_0'};

strats = {'gcv', 'lcv-smart', 'gcv-activelearning', 'lcv-activelearning'};
stratTitles = {'gcv','lcv','gcv+al','lcv+al'};

numInitial = 5;
numFinalSamples = 12;

for i=1:length(costs)
  for j=1:length(dSets)
    d = dSets{j};
    dN = dSetNames{j};
    fnames = {'','','',''};
    for k=1:length(strats)
      fnames{k} = [ '27sep3pm_' dN '_st' int2str(numInitial) '_end' ...
		     int2str(numFinalSamples) '_' strats{k} '_c_' costNames{i} ];
    end
    figName = ['test1a_' dN '_st' int2str(numInitial) '_end' ...
		     int2str(numFinalSamples) '_c_' costNames{i} ...
	       '.tiff']
    
    test1a_visualize(d, fnames{1}, fnames{2}, fnames{3}, ...
				  fnames{4}, dN, stratTitles, ...
				  ['cost= ' num2str(costs(i))]);
    print(gcf, '-dtiff', figName);
    close(gcf);
  end
  
end
