%../evaluation/simulation/eyeball/README
%
%test1: for datasets={dataA, dataB, dataD, dataE} and with cost={0.8,
%0.9, 1.0} and with strategies {gcv, lcv-smart, gcv-activelearning,
%lcv-activelearning}:
%
%   test1b: for each strat, make a plot comparing cost functions (4x 4 plots)



% test1a_run.m;


load SimData;

dSets = {dataA, dataB, dataD, dataE};
dSetNames = {'dataA', 'dataB', 'dataD', 'dataE'};

costs = [0.8, 0.9, 1.0];
costsT = {'0.8', '0.9', '1.0'};
costNames = {'0_8', '0_9', '1_0'};

strats = {'gcv', 'lcv-smart', 'gcv-activelearning', 'lcv-activelearning'};
stratTitles = {'gcv','lcv','gcv+al','lcv+al'};

numInitial = 5;
numFinalSamples = 12;

for k=1:length(strats)
  for j=1:length(dSets)
    d = dSets{j};
    dN = dSetNames{j};
    fnames = {'','',''};
    for i=1:length(costs)
      fnames{i} = [ '27sep3pm_' dN '_st' int2str(numInitial) '_end' ...
		     int2str(numFinalSamples) '_' strats{k} '_c_' costNames{i} ];
    end
    figName = ['test1b_' dN '_st' int2str(numInitial) '_end' ...
		     int2str(numFinalSamples) '_' strats{k}    '.tiff']
    
    test1b_visualize(d, fnames{1}, fnames{2}, fnames{3}, dN, costsT, ...
		     ['strategy= ' stratTitles{k}]);
    print(gcf, '-dtiff', figName);
    close(gcf);
  end
  
end
