%TO: for for strat={gcv, lcv, gcv-activelearning, lcv-activelearning},  for
%data A/B/D/E with 12 pts, for cost = {1.0}: get their rank
%w.r.t lcv score 

global topLevelCost;
global DEBUG;

DEBUG = 3;
load SimData;

dSets = {dataA, dataB, dataD, dataE};
dSetNames = {'dataA', 'dataB', 'dataD', 'dataE'};

%costs = [0.8, 0.9, 1.0];
costs = [1.0];
%costNames = {'0_8', '0_9', '1_0'};
costNames = {'1_0'};

strats = {'gcv', 'lcv-smart', 'gcv-activelearning', 'lcv-activelearning'};
stratTitles = {'gcv','lcv','gcv+al','lcv+al'};

for j=1:length(dSets)
  rndFileName = ['test2_rnd_' dSetNames{j}];
  R = load(rndFileName);
  lcvScoreRnd = R.all_lcvScore;
  rg = lcvScoreRnd;

  ranks = zeros( length(costs) * length(strats), 1);
  rankStrs = cell ( length(costs) *length(strats));
  u=1;
  
  fprintf(1,'%d random tries for %s.\n', length(rg), dSetNames{j});
  fprintf(1, 'LCV Score statistics for random: min:%2.3f median:%2.3f max:%2.3f (mean:%2.3f std:%2.3f)\n\n', min(rg), median(rg), max(rg), mean(rg), std(rg,1));

  for i=1:length(costs)
    for k=1:length(strats)
      dN = dSetNames{j};
      dname = ['test2_' dN '_' strats{k} '_c_' costNames{i} '_scores'];
      
      Dfile = load(dname);
      
      dlcvscore = Dfile.lcvScore;
      r = 1+length(find( lcvScoreRnd < dlcvscore));
      %      fprintf(1,'%s (cost=1.0) %s: %2.3f (rank vs. random: %d of %d)\n', ...
      %		 dSetNames{j},strats{k}, dlcvscore, r, length(rg));
      
      ranks(u) = r;
      rankStrs{u} = sprintf('%s (cost=1.0) %s: %2.3f (rank vs. random: %d of %d)\n', ...
			    dSetNames{j},strats{k}, dlcvscore, r, ...
			    length(rg));
      u=u+1;
    end
  end
  [a , idx] = sort(ranks);
  for k=1:length(idx)
    fprintf(1,'%s',rankStrs{idx(k)});
  end
  fprintf(1,'\n\n\n');
end

