%TO: for dataset={dataA/dataB/dataD/dataE} with approaches =
%{gcv,lcv,gcv+al,lcv+al} with cost 1 and {uniform}, find  score. for 50
%random matrices, find score and get avg, mean etc. print all.


global topLevelCost;
global DEBUG;

DEBUG = 3;
load SimData;
load FineGrainData;

fSets = {fineA, fineD, fineE};
dSets = {dataA, dataD, dataE};
dSetNames = {'dataA', 'dataD', 'dataE'};

strats = {'gcv', 'lcv-smart', 'gcv-activelearning', 'lcv-activelearning'};
stratTitles = {'gcv','lcv','gcv+al','lcv+al'};

for j=1:length(dSets)
  orig = fSets{j};
  dN = dSetNames{j};
  
  fprintf(1,'For %s:\n', dN);
  
  % get scores for Random
  routfname = ['test3_rnd_fine_' dN];
  Rfile = load(routfname);
  R = Rfile.estR;
  for r=1:size(R,1)
    x(:,:) = R(r,:,:);
    rScr(r) = test3_scoreFunc(orig,x);
  end
  
  fprintf(1,'\tRandom: mean:%2.3f stddev:%2.3f (min: %2.3f median:%2.3f max:%2.3f)\n',mean(rScr),std(rScr,1),min(rScr),median(rScr),max(rScr));
  
  % for known methods:
  for k=1:length(strats)
    dname = ['test3_fine_' dN '_' strats{k} '_c_1_0'];
    Dfile  = load(dname);
    s = test3_scoreFunc(orig, Dfile.est);
    fprintf(1,'\t%10s: %2.3f (rank %d of %d w.r.t. random)\n',stratTitles{k},s, 1+length(find(rScr<s)),length(rScr));
  end
  
  %for uniform
  uname = ['test3_unif_fine_' dSetNames{j}];
  Ufile = load(uname);
  s = test3_scoreFunc(orig, Ufile.est);
  fprintf(1,'\t%10s: %2.3f (rank %d of %d w.r.t. random)\n','uniform',s, 1+length(find(rScr<s)),length(rScr));
    
end
