load SimData;

dSets = {dataA, dataB, dataD, dataE, dataG, dataH};
dSetNames = {'dataA', 'dataB', 'dataD', 'dataE', 'dataG', 'dataH'};

for j=1:length(dSets)
  dF = ['test4_' dSetNames{j} ];
  rF = ['t4/run1/test4_rnd_' dSetNames{j} ];
  D = load(dF);
  R = load(rF);
  
  fprintf(1,'LCV+AL:\n');
  fprintf(1,'\t threshold: %.3f\n',D.threshold);
  fprintf(1,'\t Error behavior with # of timepoints:\n');
  fprintf(1,'\t\t%20s %-30s\n','# timepoints','error @ each step');
  de = D.err(D.err<1000);
  for i=1:length(de)
    fprintf(1,'\t\t%10d%10s %-20.3f\n',i+4,'',de(i));
  end
  
  fprintf(1,'\n\nRANDOM:\n');
  fprintf(1,'\t threshold: %.3f\n',R.threshold);  
  fprintf(1,'\t Error Behavior across various tries\n');
  fprintf(1,'\t\t%10s %20s %-20s\n','','# timepoints','final err');
  rn = sum(R.all_finalT,2);
  re = R.all_finalErr;
  for i=1:length(R.all_finalErr)
    fprintf(1,'\t\t%-10d %20d %-20.3f\n', i, rn(i), re(i));
  end
  
  lT = 4+length(de);
  for i=[1 4 7 8]
    x1=sprintf('lcv+al (%-d)',lT);
    x2=sprintf('#%-d (%-d)', i,rn(i));
    x3=sprintf('#%-d (%-d)', i+1,rn(i+1));
    x4=sprintf('#%-d (%-d)', i+2,rn(i+2));
    test4_visualize1(dSets{j},dF,rF,i,i+1,i+2,dSetNames{j}, {x1,x2,x3,x4}, ...
		     '# timepts in parentheses');
    figname = sprintf('test4_%s_%d%d%d.tiff',dSetNames{j},i,i+1,i+2);
    print (gcf,'-dtiff',figname);
    close(gcf);
  end
  
  
end
