load SimData;

dSets = {dataA, dataB, dataD, dataE, dataG, dataH, dataI};
dSetNames = {'dataA', 'dataB', 'dataD', 'dataE', 'dataG', 'dataH', 'dataI'};

for j=[1 2 3]%1:length(dSets)
  dF = ['/toc/home/rsingh/courses/6874/project/sampling/src/t4/run2/test4_' dSetNames{j} ];
  rF = ['/toc/home/rsingh/courses/6874/project/sampling/src/t4/run2/test4_rnd_' dSetNames{j} ];
  
  D = load(dF);
  R = load(rF);
  
  errMetric = zeros(1,24);
  errDesc = 'gcv error';
  errRange = [3.8:-0.1:2.0];
  
  
  fprintf(1,'LCV+AL  vs. RANDOM:\n');
  fprintf(1,'\t threshold: %.3f\n',D.threshold);
  fprintf(1,'\t Error (%s) behavior with # of timepoints:\n',errDesc);
  
  all=1:24;
  dN = D.numFinalSamples;
  
  for e=errRange
    
    di = all(D.err<e);
    if (length(di)>0)
      lcvalstr=sprintf('%-10s: %2d timepoints required','LCV+AL', ...
		       min(di));
      lcvalscore = min(di);
    else
      lcvalstr=sprintf('%-10s: >20 timepoints required','LCV+AL');
      lcvalscore = 24;
    end
  
    rCnt=[];
    for i=1:10
      x=R.all_err(i,:);
      xi = all(x<e);
      if (length(xi)>0)
	rCnt(end+1)=min(xi);
      end
    end
    if (length(rCnt)>0)
      rndstr =sprintf('%-10s: (%d of 10 PASS). timepoints required: (median=%3.1f mean=%3.1f)','RANDOM', length(rCnt), median(rCnt), mean(rCnt));
      rndscore = median(rCnt);
    else
      rndstr = sprintf('%-10s: >22 timepoints required','RANDOM');
      rndscore= 24;
    end
    
    if (lcvalscore<=rndscore)
      fprintf(1,'error=%5.3f . LCV+AL performs better/equal\n',e);
    else
      fprintf(1,'error=%5.3f . RANDOM performs better\n',e);
    end
    fprintf(1,'%s\n%s\n\n', lcvalstr,rndstr);      
      
  end
  
end
