load SimData;

dSets = {dataA, dataB, dataD, dataE, dataG, dataH, dataI};
dSetNames = {'dataA', 'dataB', 'dataD', 'dataE', 'dataG', 'dataH', 'dataI'};
dQual     = {'normal','very hard','normal','hard','hard','hard','very hard'};
trueErrThreshold = 0.15;

doTrueErrVsTimePoints=1;
doTrueErrVsGcvError=0;
doPlotCurves = 0;
doTrueErrVsCurveSigma = 0;
for j=1:length(dSets)

  [dPlotMat, rPlotMat, dStopAt, rStopAt] = ...
      test4_anlyz_trueErrvsTimePts(j,trueErrThreshold);

  if (doTrueErrVsTimePoints)
  %BEGIN true error vs timepoints
  subplot(1,2,1);
  
  plot(dPlotMat(:,1), dPlotMat(:,2),'k-',rPlotMat(:,1), rPlotMat(:,2),'r-',dPlotMat(:,1), dPlotMat(:,2),'ko',rPlotMat(:,1), ...
       rPlotMat(:,2),'ro',[4 22], [trueErrThreshold trueErrThreshold], ...
       'g--',[dStopAt dStopAt],[0 dPlotMat(dStopAt-4,2)],'k-.',[rStopAt rStopAt],[0 rPlotMat(rStopAt-4,2)],'r-.');
  xlabel('Number of Timepoints');
  ylabel('True Error');
  v = axis;
  axis([4 23 v(3) v(4)]);
  s=sprintf('%s : %s',dQual{j},dSetNames{j});
  legend('LCV + AL','Random');
  title(s,'FontSize', 11,'FontWeight','bold');  
  %END true error vs timepoints
  end
  
  if (doTrueErrVsGcvError)
  %BEGIN true error vs gcv error

subplot(1,2,1);
  
  err_desc='GCV Error';

  [dIdx,dTrueErr,dErrMetric,rIdx,rTrueErr,rErrMetric] = ...
      test4_anlyz_trueErrvsErrMetric(j, trueErrThreshold, dPlotMat, rPlotMat, dStopAt, rStopAt, err_desc);
  
  err_min =min([dErrMetric rErrMetric])-0.3;
  err_max =err_min+3;

  [a, sortR] = sort(rTrueErr);
  [b, sortD] = sort(dTrueErr);
  plot(dErrMetric(sortD),dTrueErr(sortD),'k-',rErrMetric(sortR),  rTrueErr(sortR),'r-',dErrMetric(sortD),dTrueErr(sortD),'ko',rErrMetric(sortR),rTrueErr(sortR),'ro');
  v = axis;
  ymin = min([dTrueErr rTrueErr]) -0.02;
  axis([err_min err_max  ymin 0.35]);
  v = axis;
  
  hold on;
  plot([v(1) v(2)],[trueErrThreshold trueErrThreshold],'g--');
  
  v= axis;
  lD = 1:length(dTrueErr);
  xD = max(dErrMetric(lD(dTrueErr<=trueErrThreshold)));
  lR = 1:length(rTrueErr);
  xR = max(rErrMetric(lR(rTrueErr<=trueErrThreshold)));  
  
  plot([xD xD], [v(3) v(4)], 'k-.');
  plot([xR xR], [v(3) v(4)], 'r-.');  
  
  hold off;
  s1 = sprintf('Error measured using %s',err_desc);
  xlabel(s1);
  ylabel('True Error');
  legend('LCV + AL','Random');
  
  s=sprintf('%s : %s (Err quality)',dQual{j},dSetNames{j});
  title(s,'FontSize', 11,'FontWeight','bold');  
  %END true error vs gcv error
  end

  if (doTrueErrVsCurveSigma)
  %BEGIN true error vs curve sigma

subplot(1,2,2);
  
  %err_desc='Curve Sigma';
  %err_desc='Worst Cluster Sigma';
  err_desc='GCV Error with NumCPs';
  
  [dIdx,dTrueErr,dErrMetric,rIdx,rTrueErr,rErrMetric] = ...
      test4_anlyz_trueErrvsErrMetric(j, trueErrThreshold, dPlotMat, rPlotMat, dStopAt, rStopAt, err_desc);
  
  err_min =min([dErrMetric rErrMetric])-0.2;
  err_max =err_min+4;

  [a, sortR] = sort(rTrueErr);
  [b, sortD] = sort(dTrueErr);
  plot(dErrMetric(sortD),dTrueErr(sortD),'k-',rErrMetric(sortR),  rTrueErr(sortR),'r-',dErrMetric(sortD),dTrueErr(sortD),'ko',rErrMetric(sortR),rTrueErr(sortR),'ro');
  v = axis;
  ymin = min([dTrueErr rTrueErr]) -0.02;
  axis([err_min err_max  ymin 0.35]);
  v = axis;
  
  hold on;
  plot([v(1) v(2)],[trueErrThreshold trueErrThreshold],'g--');
  
  v= axis;
  lD = 1:length(dTrueErr);
  xD = max(dErrMetric(lD(dTrueErr<=trueErrThreshold)));
  lR = 1:length(rTrueErr);
  xR = max(rErrMetric(lR(rTrueErr<=trueErrThreshold)));  
  
  plot([xD xD], [v(3) v(4)], 'k-.');
  plot([xR xR], [v(3) v(4)], 'r-.');  
  
  hold off;
  s1 = sprintf('Error measured using %s',err_desc);
  xlabel(s1);
  ylabel('True Error');
  legend('LCV + AL','Random');
  
  s=sprintf('%s : %s (Err quality)',dQual{j},dSetNames{j});
  title(s,'FontSize', 11,'FontWeight','bold');  
  %END true error vs gcv error
  end

  
  if (doPlotCurves)
    dF=['/toc/home/rsingh/courses/6874/project/sampling/src/t4/run2/test4_' ...
	dSetNames{j} ];
    rF = ['/toc/home/rsingh/courses/6874/project/sampling/src/t4/run2/test4_rnd_' dSetNames{j} ];
    
    K = dStopAt;
    for i=[1 4 7 8]
      x1=sprintf('lcv+al (%-d)',K);
      x2=sprintf('#%-d (%-d)', i,K);
      x3=sprintf('#%-d (%-d)', i+1,K);
      x4=sprintf('#%-d (%-d)', i+2,K);
      test4_visualize2(dSets{j},dF,K,rF,i,i+1,i+2,dSetNames{j}, {x1,x2,x3,x4}, ...
		     '# timepts in parentheses');
      figname = sprintf('test4_%s_optml_%d%d%d.tiff',dSetNames{j},i,i+1,i+2);
      print (gcf,'-dtiff',figname);
      close(gcf);
    end    
  
    K = dStopAt+2;
    for i=[1 4 7 8]
      x1=sprintf('lcv+al (%-d)',K);
      x2=sprintf('#%-d (%-d)', i,K);
      x3=sprintf('#%-d (%-d)', i+1,K);
      x4=sprintf('#%-d (%-d)', i+2,K);
      test4_visualize2(dSets{j},dF,K,rF,i,i+1,i+2,dSetNames{j}, {x1,x2,x3,x4}, ...
		     '# timepts in parentheses');
      figname = sprintf('test4_%s_optml_plus2_%d%d%d.tiff',dSetNames{j},i,i+1,i+2);
      print (gcf,'-dtiff',figname);
      close(gcf);
    end    

  end
  
  
  %figname = sprintf('test4_2in1_gcverror_%s.tiff',dSetNames{j});
  %print(gcf, '-dtiff',figname);
  figure;
end
close;


