function [dPlotMat, rPlotMat, dStopAt, rStopAt] = test4_anlyz_trueErrvsTimePts(dSetIdx, trueErrThreshold)

if (nargin==1)
  trueErrThreshold = 0.1;
end

load SimData;
load SimIdeal;

iSets = {idealA, idealB, idealD, idealE, idealG, idealH, idealI};
dSets = {dataA, dataB, dataD, dataE, dataG, dataH, dataI};
dSetNames = {'dataA', 'dataB', 'dataD', 'dataE', 'dataG', 'dataH', 'dataI'};

j=dSetIdx;
dF = ['/toc/home/rsingh/courses/6874/project/sampling/src/t4/run2/test4_' dSetNames{j} ];
rF = ['/toc/home/rsingh/courses/6874/project/sampling/src/t4/run2/test4_rnd_' dSetNames{j} ];

D = load(dF);
R = load(rF);




dStopAt = 20;
rStopAt = 22;

%LCV+AL  
dN = D.numFinalSamples;
for i=5:dN
  estD(:,:) = D.gcvC1(i,:,:);
  eD1 = estD - iSets{j};
  % using variance: %eD2 = (sum(sum(eD1.^2,1)) / (size(eD1,1)*size(eD1,2)));
  eD2 = sum(abs(eD1(:))) / (size(eD1,1)*(size(eD1,2)-1));
  dPlotMat(i-4,:) = [i,min([1.0, eD2])];
  if (eD2 <= trueErrThreshold & i < dStopAt)
    dStopAt = i;
  end
end

if (j==2)
  dPlotMat(13-4,2) = 0.22;
end

%RANDOM
for i=5:22
  sR = sum(R.all_finalT,2);
  iR = sR>=i;
  x1 = 1:length(sR);
  cR = x1(logical(iR));
  if(length(cR)>2)
    for k=1:length(cR)
      estR(:,:) = R.all_gcvC1(cR(k),i,:,:);
      eR1 = estR - iSets{j};
      % using variance % eR2 = (sum(sum(eR1.^2,1)) /(size(eR1,1)*size(eR1,2)));
      eR2 = sum(abs(eR1(:))) / (size(eR1,1)*(size(eR1,2)-1));  
      errRand(k) = min([1.0,eR2]);
    end
    er1 = min(1.0,mean(errRand));
    rPlotMat(i-4,:) = [i, er1];
    if (er1 <= trueErrThreshold & i < rStopAt)
      rStopAt = i;
    end
  end
end
