X1 = sin([0:11 12 11:-1:1] * (pi/24));
Y1 = zeros(1,24);
Y1(9:16) = sin([1:4 3:-1:0] * (pi/8));
Y1

X= repmat(X1,50,1);
Y= repmat(Y1,50,1);

global topLevelCost;
global imposeGCVcpLimit;

topLevelCost=1;
imposeGCVcpLimit=1;

initCI = ones(1,N)*-1; 

allTimes = [1:24]';
Tindxs = [1 4 8 12 16 20 24]';

N = length(allTimes);
n= length(Tindxs);


[x_gcvI, x_Agcv, x_C1gcv, x_C2gcv, x_Na_gcv, x_gcvScore, x_sig, x_gcv_alli, x_gcv_allC1, ...
 x_gcv_allNa, x_gcv_allSig] = findLambdaG(X, Tindxs, allTimes, 1, 5,0,5);
 

[y_gcvI, y_Agcv, y_C1gcv, y_C2gcv, y_Na_gcv, y_gcvScore, y_sig, y_gcv_alli, y_gcv_allC1, ...
 y_gcv_allNa, y_gcv_allSig] = findLambdaG(Y, Tindxs, allTimes, 1, 5,0,5);


x_CIgcv = initCI;

for i=1:n
  x_CIgcv(Tindxs(i)) = CI(x_Agcv(i,i), sqrt(x_sig));
end

y_CIgcv = initCI;

for i=1:n
  y_CIgcv(Tindxs(i)) = CI(y_Agcv(i,i), sqrt(y_sig));
end

[x_lcvCntrlPts, x_lcv_Scores] = lcv(X, Tindxs, allTimes, x_gcvI, x_gcv_alli, ...
				x_gcv_allC1, x_gcv_allNa);

x_CIlcv = initCI;

for i=1:n
  s_i = getS( allTimes(Tindxs), x_lcvCntrlPts(i));
  A_i = s_i * pinv(s_i);
  x_CIlcv(Tindxs(i)) = CI(A_i(i,i), sqrt(x_sig));
end

[y_lcvCntrlPts, y_lcv_Scores] = lcv(Y, Tindxs, allTimes, y_gcvI, y_gcv_alli, ...
				y_gcv_allC1, y_gcv_allNa);

y_lcvCntrlPts([3,5])=6;
y_lcvCntrlPts(4)=7;

y_CIlcv = initCI;

for i=1:n
  s_i = getS( allTimes(Tindxs), y_lcvCntrlPts(i));
  A_i = s_i * pinv(s_i);
  y_CIlcv(Tindxs(i)) = CI(A_i(i,i), sqrt(y_sig));
end

close;

subplot(1,2,1);
H=errorbar(Tindxs+0.5,x_C1gcv(1,Tindxs),x_CIgcv(Tindxs),'b');
delete(H(2));
set(H(1),'Linewidth',2);
set(H(1),'LineStyle','--');
hold on
H=errorbar(Tindxs-0.5,x_C1gcv(1,Tindxs),x_CIlcv(Tindxs),'b');
delete(H(2));
set(H(1),'Linewidth',2);
plot(allTimes,x_C1gcv(1,:),'b','Linewidth',1);
plot(Tindxs, X(1,Tindxs),'r*');
plot(Tindxs, X(1,Tindxs),'ro');
plot(allTimes,X(1,:),'r--','Linewidth',1);


%subplot(2,2,2);
%H=errorbar(Tindxs,x_C1gcv(1,Tindxs),x_CIlcv(Tindxs),'b');
%delete(H(2));%set(H(2),'Linewidth',.01);
%hold on
%plot(allTimes,x_C1gcv(1,:),'b','Linewidth',3);
%plot(Tindxs, X(1,Tindxs),'r*');
%plot(allTimes,X(1,:),'r--','Linewidth',2);

subplot(1,2,2);
H=errorbar(Tindxs+0.5,y_C1gcv(1,Tindxs),y_CIgcv(Tindxs),'b--');
delete(H(2));
set(H(1),'Linewidth',2);
set(H(1),'LineStyle','--');
hold on
H=errorbar(Tindxs-0.5,y_C1gcv(1,Tindxs),y_CIlcv(Tindxs),'b');
delete(H(2));
set(H(1),'Linewidth',2);
plot(allTimes,y_C1gcv(1,:),'b','Linewidth',1);
plot(Tindxs, Y(1,Tindxs),'r*');
plot(Tindxs, Y(1,Tindxs),'ro');
plot(allTimes,Y(1,:),'r--','Linewidth',1);


%subplot(2,2,4);
%H=errorbar(Tindxs,y_C1gcv(1,Tindxs),y_CIlcv(Tindxs),'b');
%delete(H(2));%set(H(2),'Linewidth',.01);
%hold on
%plot(allTimes,y_C1gcv(1,:),'b','Linewidth',3);
%plot(Tindxs, Y(1,Tindxs),'r*');
%plot(allTimes,Y(1,:),'r--','Linewidth',2);
