X1 = sin([0:11 12 11:-1:1] * (pi/24));

X= repmat(X1,50,1);

global topLevelCost;
global imposeGCVcpLimit;

topLevelCost=1;
imposeGCVcpLimit=1;

initCI = ones(1,N)*-1; 

allTimes = [1:24]';
Tindxs = [1 4 8 12 16 20 24]';

N = length(allTimes);
n= length(Tindxs);


[x_gcvI, x_Agcv, x_C1gcv, x_C2gcv, x_Na_gcv, x_gcvScore, x_sig, x_gcv_alli, x_gcv_allC1, ...
 x_gcv_allNa, x_gcv_allSig] = findLambdaG(X, Tindxs, allTimes, 1, 5,0,5);
 

x_CIgcv = initCI;

for i=1:n
  x_CIgcv(Tindxs(i)) = CI(x_Agcv(i,i), sqrt(x_sig));
end

for i=1:n-1
  distance = Tindxs(i+1) - Tindxs(i); % distance to next sampled point
  for k=Tindxs(i)+1:Tindxs(i+1)-1
    Tindxs_k = [Tindxs(1:i) ; k; Tindxs(i+1:end)];
    s_k = getS( allTimes(Tindxs_k), x_gcvI);
    A_k = s_k * pinv(s_k);
    x_CIgcv(k) = CI( A_k(i+1,i+1), sqrt(x_sig));
  end
end

fplus = x_C1gcv(1,:) + x_CIgcv;
fminus = x_C1gcv(1,:) - x_CIgcv;

close
H=errorbar(Tindxs,x_C1gcv(1,Tindxs),x_CIgcv(Tindxs),'b');
delete(H(2));
set(H(1),'Linewidth',2);
hold on;
plot(allTimes,x_C1gcv(1,:),'k','Linewidth',2);
plot(allTimes,fplus,'r-.','Linewidth',2);
plot(allTimes,fminus,'r-.','Linewidth',2);
plot(Tindxs,fplus(Tindxs),'b','Linewidth',1);
plot(Tindxs,fminus(Tindxs),'b','Linewidth',1);
