%TO: for dataG/H create 150x231 matrix with values that are more
%finely sampled than dataG/H

load SimData;

m = 10;
f = 1.0/m;
rf = (m-1)*f;

T0 = 24;
T = T0*m;
times = 0:T-1;

% the max is typically 1. and the std dev is always 0.2
rng = 1;
stdDev = 0.2; % NOTE: we keep the ideal. so no deviation. 0.2;

totalSize = 150;
numClusters = 3;
clusterSize = totalSize/ numClusters;

% dataA


a1 = [0:f:11+rf  0:f:11+rf] * 2 *pi / 12; % 0..2pi over 2 cycles
X1 = rng*repmat(sin(a1), clusterSize,1) + stdDev*randn(clusterSize,T);
K1 = sin(a1);

a2 = [3:f:11+rf 0:f:11+rf 0:f:2+rf] * 2 * pi/ 12; %0..2pi over 2 cycles, with phase
                                   %pi/2
X2 = rng*repmat(sin(a2), clusterSize,1) + stdDev*randn(clusterSize,T);
K2 = sin(a2);

X3 = stdDev*randn(clusterSize,T);
K3 = zeros(1,T);

fA = [X1; X2; X3];

% dataB

a1 = [0:f:11+rf zeros(1,12*m)] ; % will use sin(0) = 0
X1 = rng*repmat(sin(a1), clusterSize,1) + stdDev*randn(clusterSize,T);
K1 = sin(a1);

a2 = [zeros(1,12*m) 0:f:11+rf];
X2 = rng*repmat(sin(a2), clusterSize,1) + stdDev*randn(clusterSize,T);
K2 = sin(a2);

X3 = stdDev*randn(clusterSize,T);
K3 = zeros(1,T);

fB = [X1; X2; X3];


% dataD
a1 = [zeros(1,6*m) 0:f:11+rf zeros(1,6*m)] * 2 *pi / 12; % 0..2pi over 1 cycle
X1 = rng*repmat(sin(a1), clusterSize,1) + stdDev*randn(clusterSize,T);
K1 = sin(a1);

X2 = -X1;
K2 = -K1;

X3 = stdDev*randn(clusterSize,T);
K3 = zeros(1,T);

fD = [X1; X2; X3];

% dataE
a1 = [0:f:11+rf zeros(1,12*m)] * 2 * pi / 12; % will use sin(0) = 0
X1 = rng*repmat(sin(a1), clusterSize,1) + stdDev*randn(clusterSize,T);
K1 = sin(a1);

a2 = -a1;
X2 = rng*repmat(sin(a2), clusterSize,1) + stdDev*randn(clusterSize,T);
K2 = sin(a2);

X3 = stdDev*randn(clusterSize,T);
K3 = zeros(1,T);

fE = [X1; X2; X3];

% dataG
a1 = [0:f:11+rf zeros(1,12*m)] ; % will use sin(0) = 0
X1 = rng*repmat(sin(a1), clusterSize,1) + stdDev*randn(clusterSize,T);
K1 = sin(a1);

a2 = -a1;
X2 = rng*repmat(sin(a2), clusterSize,1) + stdDev*randn(clusterSize,T);
K2 = sin(a2);

X3 = stdDev*randn(clusterSize,T);
K3 = zeros(1,T);

fG = [X1; X2; X3];

% dataH
a1 = [0:f:7+rf zeros(1,16*m)] * 2 *pi / 8;
X1 = rng*repmat(sin(a1), clusterSize,1) + stdDev*randn(clusterSize,T);
K1 = sin(a1);

a2 = -a1;
X2 = rng*repmat(sin(a2), clusterSize,1) + stdDev*randn(clusterSize,T);
K2 = sin(a2);

X3 = stdDev*randn(clusterSize,T);
K3 = zeros(1,T);

fH = [X1; X2; X3];

% dataI

a1 = [0:f:11+rf zeros(1,12*m)] ; % will use sin(0) = 0
b1 = [9:-0.5*f:3.5-(0.5*rf) zeros(1,12*m)]/9.0 .* sin(a1);
X1 = rng*repmat(b1, clusterSize,1) + stdDev*randn(clusterSize,T);
K1 = sin(a1);

a2 = [0:f:11+rf zeros(1,12*m)] ; % will use sin(0) = 0
b2 = [9:-0.5*f:3.5-(0.5*rf) zeros(1,12*m)]/9.0 .* sin(a2);
X2 = -rng*repmat(b2, clusterSize,1) + stdDev*randn(clusterSize,T);
K2 = sin(a2);

X3 = stdDev*randn(clusterSize,T);
K3 = zeros(1,T);

fI = [X1; X2; X3];


% splice in dataA/D/E where they should be
I = 1 + m*(0:T0-1);
%fA(:,I) = dataA(:,:);
%fD(:,I) = dataD(:,:);
%fE(:,I) = dataE(:,:);
%fG(:,I) = dataG(:,:);
%fH(:,I) = dataH(:,:);

efineA(:,:) = fA(:,1:231);
efineB(:,:) = fB(:,1:231);
efineD(:,:) = fD(:,1:231);
efineE(:,:) = fE(:,1:231);
efineG(:,:) = fG(:,1:231);
efineH(:,:) = fH(:,1:231);
efineI(:,:) = fI(:,1:231);

save test9_fineWithErrData efine*;
