function lam = findMue(Y,AllS,Gamma,num,cl,grid,expNum,prob);

% Y - Y a matrix, each column corresponds to a gene.
% AllS - Collection of matrices for each gene
% Gamma - Matrix of the currently estimated Gammas
% num - num of genes
% cl - num of clasess 
% grid - number of control points
% expNum - number of experiments
% prob - probability of each class

lam = zeros(grid,cl);
curS = zeros(grid,grid,cl);
for i=1:num,
  S = AllS(:,:,i);
  for j=1:cl,
    curS(:,:,j) = curS(:,:,j) + prob(j,i)*(S'*S);
    lam(:,j) = lam(:,j) + prob(j,i)*(S'*(Y(:,i) - S*Gamma(:,i,j)));
  end
end
for i=1:cl,
  lam(:,i) = curS(:,:,i)^(-1)*lam(:,i);
end
