function lam = findMue(Y,AllS,Gamma,num,cl,grid,expNum,c);

% Y - Y a matrix, each column corresponds to a gene.
% AllS - Collection of matrices for each gene
% Gamma - Matrix of the currently estimated Gammas
% num - num of genes
% cl - num of clasess 
% expNum - number of experiments
% c - known class assignment

lam = zeros(grid,cl);
curS = zeros(grid,grid,cl);
for i=1:num,
  S = AllS(:,:,i);
  curS(:,:,c(i)) = curS(:,:,c(i)) + (S'*S);
  lam(:,c(i)) = lam(:,c(i)) + (S'*(Y(:,i) - S*Gamma(:,i)));
end
for i=1:cl,
  if (rcond(curS(:,:,i))< 1e-14)
    error('interK.m:SingularMatrix','interK.m:SingularMatrix');
  end
  lam(:,i) = curS(:,:,i)^(-1)*lam(:,i);
end
